# remirepo/Fedora spec file for php-zendframework-zend-mvc-plugin-flashmessenger
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    1af2e2d69500da5ca31868c4817b6b7eb7e1cf47
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mvc-plugin-flashmessenger
%global php_home     %{_datadir}/php
%global library      FlashMessenger
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.1.0
Release:        1%{?dist}
Summary:        Zend Framework Mvc-Plugin-%{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-session)          >= 2.6.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7.5
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-i18n": "^2.8"
BuildRequires: (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-view)             >= 2.10  with php-autoloader(%{gh_owner}/zend-view)             <  3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-i18n)             >= 2.8   with php-autoloader(%{gh_owner}/zend-i18n)             <  3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-mvc": "^3.0",
#        "zendframework/zend-session": "^2.8.5",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
#        "zendframework/zend-view": "^2.10"
Requires:       php(language) >= 5.6
Requires:      (php-autoloader(%{gh_owner}/zend-mvc)              >= 3.0   with php-autoloader(%{gh_owner}/zend-mvc)              <  4)
Requires:      (php-autoloader(%{gh_owner}/zend-session)          >= 2.8.5 with php-autoloader(%{gh_owner}/zend-session)          <  3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)           <  4)
Requires:      (php-autoloader(%{gh_owner}/zend-view)             >= 2.10  with php-autoloader(%{gh_owner}/zend-view)             <  3)
# From composer, "suggests": {
#        "zendframework/zend-i18n": "Zend\\I18n component"
Suggests:       php-autoloader(%{gh_owner}/zend-i18n)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.0.0
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Flash messages derive from Rails, and are used to expose messages from one
action to the next, after which they are cleared; a typical use case is with
Post/Redirect/Get, where they are created in the POST handler, and then
displayed by the GET handler to indicate success or failure to the end-user.

This component provides a flash messenger controller plugin for zend-mvc
versions 3.0 and up.

* Issues at https://github.com/zendframework/zend-mvc-plugin-flashmessenger/issues
* Documentation is at https://zendframework.github.io/zend-mvc-plugin-flashmessenger/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Mvc/Plugin
cp -pr src %{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Mvc/Plugin/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Mvc\\Plugin\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Mvc/Plugin/%{library}


%changelog
* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0
- raise dependency on zend-session 2.8.5
- add dependency on zend-view
- use range dependencies
- switch to phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 1.0.0-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.0.0-1
- initial package

